// ###########################################################################
// File: ECallback7T.h
// (c)Copyright 03/1999, Gaia Creation, Baptiste Lepilleur
// ###########################################################################
#if !defined(AFX_ECALLBACK7T_H__B78AA267_D476_11D2_BD55_0040053AD648__INCLUDED_)
#define AFX_ECALLBACK7T_H__B78AA267_D476_11D2_BD55_0040053AD648__INCLUDED_


#include "EBaseCallback.h"

/*! 
 * \brief This class provides a callback without parameters and return value.
 */
template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7>
class ECallback7T : protected EBaseCallback
{
public:
  ECallback7T() {}

  /*! Tests if the callback has been set.
   * @return \c true if the callback has been set, otherwise \c false.
   */
  operator bool() const;

  /*! Calls the callback.
   */
  void operator ()(TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7) const;


  typedef void (*ECallerFn)(const EBaseCallback &cb, TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7);

  ECallback7T( ECallerFn fnCaller,
             void *pObjReceiver,
             const void *fnMember,
             size_t nSizeFnMember );

private:
  ECallerFn _fnCaller;
};



template< class Function,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7 >
class ECallbackCallerFn7T : public ECallback7T<TP1,TP2,TP3,TP4,TP5,TP6,TP7>
{
public:
  ECallbackCallerFn7T( Function fnCallback );

  static void caller( const EBaseCallback &cb, TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7 );
};

/*! \brief This class provides a Prototype for static method callback.
 */
template<class ReturnType,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7
         ,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn,class TP7Fn>
inline ECallbackCallerFn7T< ReturnType (*)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn)
                                   ,TP1,TP2,TP3,TP4,TP5,TP6,TP7 >
eCbCreator( ECallback7T<TP1,TP2,TP3,TP4,TP5,TP6,TP7> *, 
                         ReturnType (*fn)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn) )
{
  return ECallbackCallerFn7T< ReturnType (*)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn)
                            ,TP1,TP2,TP3,TP4,TP5,TP6,TP7>( fn );
}

template< class Receiver, class Member,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7>
class ECallbackCallerMember7T : public ECallback7T<TP1,TP2,TP3,TP4,TP5,TP6,TP7>
{
public:
  ECallbackCallerMember7T( Receiver *pObjReceiver, 
                                  const Member &fnMember );


  static void caller( const EBaseCallback &cb, TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7 );
};


template< class Receiver, class CallObjType
,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn,class TP7Fn
,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class ReturnType >
inline ECallbackCallerMember7T< Receiver, 
                                       ReturnType (CallObjType::*)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn)
                                       ,TP1,TP2,TP3,TP4,TP5,TP6,TP7 >
eCbCreator( ECallback7T<TP1,TP2,TP3,TP4,TP5,TP6,TP7> *,
            Receiver &objReceiver,
            ReturnType (CallObjType::* const &fnMemberCallback)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn) )
{
  typedef ReturnType (CallObjType::*MemberCallback)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn);

  return ECallbackCallerMember7T< Receiver, MemberCallback
                                ,TP1,TP2,TP3,TP4,TP5,TP6,TP7>( &objReceiver,
                                                            fnMemberCallback );
}






// ###################################################################
// Inline methods:
// ###################################################################


template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7>
inline 
ECallback7T<TP1,TP2,TP3,TP4,TP5,TP6,TP7>::operator bool() const
{
  return isValid();
}


template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7>
inline 
void
ECallback7T<TP1,TP2,TP3,TP4,TP5,TP6,TP7>::operator ()(TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7) const
{
   _fnCaller( *this, p1,p2,p3,p4,p5,p6,p7 );
}


template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7>
inline
ECallback7T<TP1,TP2,TP3,TP4,TP5,TP6,TP7>::ECallback7T( ECallerFn fnCaller,
                      void *pObjReceiver,
                      const void *fnMember,
                      size_t nSizeFnMember ) :
    EBaseCallback( pObjReceiver,
                   fnMember,
                   nSizeFnMember ),
    _fnCaller( fnCaller )
{
}


template< class Function,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7 >
inline
ECallbackCallerFn7T< Function,TP1,TP2,TP3,TP4,TP5,TP6,TP7 >::ECallbackCallerFn7T( Function fnCallback ) :
    ECallback7T<TP1,TP2,TP3,TP4,TP5,TP6,TP7>( caller, NULL, fnCallback, 0 )
{
}


template< class Function,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7 >
inline void
ECallbackCallerFn7T< Function,TP1,TP2,TP3,TP4,TP5,TP6,TP7 >::caller( const EBaseCallback &cb, TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7 )
{
   ((Function)cb._fnCallback)(p1,p2,p3,p4,p5,p6,p7);
}


template< class Receiver, class Member,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7 >
inline 
ECallbackCallerMember7T<Receiver,Member,TP1,TP2,TP3,TP4,TP5,TP6,TP7>::ECallbackCallerMember7T( Receiver *pObjReceiver, 
                                                               const Member &fnMember ) :
    ECallback7T<TP1,TP2,TP3,TP4,TP5,TP6,TP7>( caller, pObjReceiver, &fnMember, sizeof( fnMember ) )
{
}

template< class Receiver, class Member,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7 >
inline void
ECallbackCallerMember7T<Receiver,Member,TP1,TP2,TP3,TP4,TP5,TP6,TP7>::caller( const EBaseCallback &cb, TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7 )
{
  Receiver &objReceiver = *(Receiver *)cb._pObjReceiver;
  Member &fnMember = *(Member *)(void *)cb._fnMemberCallback;

   (objReceiver.*fnMember)(p1,p2,p3,p4,p5,p6,p7);
}

#endif // !defined(AFX_ECALLBACK7T_H__B78AA267_D476_11D2_BD55_0040053AD648__INCLUDED_)
