// ###########################################################################
// File: ECallback9T.h
// (c)Copyright 03/1999, Gaia Creation, Baptiste Lepilleur
// ###########################################################################
#if !defined(AFX_ECALLBACK9T_H__B78AA269_D476_11D2_BD55_0040053AD648__INCLUDED_)
#define AFX_ECALLBACK9T_H__B78AA269_D476_11D2_BD55_0040053AD648__INCLUDED_


#include "EBaseCallback.h"

/*! 
 * \brief This class provides a callback without parameters and return value.
 */
template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9>
class ECallback9T : protected EBaseCallback
{
public:
  ECallback9T() {}

  /*! Tests if the callback has been set.
   * @return \c true if the callback has been set, otherwise \c false.
   */
  operator bool() const;

  /*! Calls the callback.
   */
  void operator ()(TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8,TP9 p9) const;


  typedef void (*ECallerFn)(const EBaseCallback &cb, TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8,TP9 p9);

  ECallback9T( ECallerFn fnCaller,
             void *pObjReceiver,
             const void *fnMember,
             size_t nSizeFnMember );

private:
  ECallerFn _fnCaller;
};



template< class Function,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9 >
class ECallbackCallerFn9T : public ECallback9T<TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9>
{
public:
  ECallbackCallerFn9T( Function fnCallback );

  static void caller( const EBaseCallback &cb, TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8,TP9 p9 );
};

/*! \brief This class provides a Prototype for static method callback.
 */
template<class ReturnType,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9
         ,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn,class TP7Fn,class TP8Fn,class TP9Fn>
inline ECallbackCallerFn9T< ReturnType (*)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn,TP8Fn,TP9Fn)
                                   ,TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9 >
eCbCreator( ECallback9T<TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9> *, 
                         ReturnType (*fn)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn,TP8Fn,TP9Fn) )
{
  return ECallbackCallerFn9T< ReturnType (*)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn,TP8Fn,TP9Fn)
                            ,TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9>( fn );
}

template< class Receiver, class Member,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9>
class ECallbackCallerMember9T : public ECallback9T<TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9>
{
public:
  ECallbackCallerMember9T( Receiver *pObjReceiver, 
                                  const Member &fnMember );


  static void caller( const EBaseCallback &cb, TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8,TP9 p9 );
};


template< class Receiver, class CallObjType
,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn,class TP7Fn,class TP8Fn,class TP9Fn
,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9,class ReturnType >
inline ECallbackCallerMember9T< Receiver, 
                                       ReturnType (CallObjType::*)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn,TP8Fn,TP9Fn)
                                       ,TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9 >
eCbCreator( ECallback9T<TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9> *,
            Receiver &objReceiver,
            ReturnType (CallObjType::* const &fnMemberCallback)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn,TP8Fn,TP9Fn) )
{
  typedef ReturnType (CallObjType::*MemberCallback)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn,TP8Fn,TP9Fn);

  return ECallbackCallerMember9T< Receiver, MemberCallback
                                ,TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9>( &objReceiver,
                                                            fnMemberCallback );
}






// ###################################################################
// Inline methods:
// ###################################################################


template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9>
inline 
ECallback9T<TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9>::operator bool() const
{
  return isValid();
}


template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9>
inline 
void
ECallback9T<TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9>::operator ()(TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8,TP9 p9) const
{
   _fnCaller( *this, p1,p2,p3,p4,p5,p6,p7,p8,p9 );
}


template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9>
inline
ECallback9T<TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9>::ECallback9T( ECallerFn fnCaller,
                      void *pObjReceiver,
                      const void *fnMember,
                      size_t nSizeFnMember ) :
    EBaseCallback( pObjReceiver,
                   fnMember,
                   nSizeFnMember ),
    _fnCaller( fnCaller )
{
}


template< class Function,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9 >
inline
ECallbackCallerFn9T< Function,TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9 >::ECallbackCallerFn9T( Function fnCallback ) :
    ECallback9T<TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9>( caller, NULL, fnCallback, 0 )
{
}


template< class Function,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9 >
inline void
ECallbackCallerFn9T< Function,TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9 >::caller( const EBaseCallback &cb, TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8,TP9 p9 )
{
   ((Function)cb._fnCallback)(p1,p2,p3,p4,p5,p6,p7,p8,p9);
}


template< class Receiver, class Member,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9 >
inline 
ECallbackCallerMember9T<Receiver,Member,TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9>::ECallbackCallerMember9T( Receiver *pObjReceiver, 
                                                               const Member &fnMember ) :
    ECallback9T<TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9>( caller, pObjReceiver, &fnMember, sizeof( fnMember ) )
{
}

template< class Receiver, class Member,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9 >
inline void
ECallbackCallerMember9T<Receiver,Member,TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9>::caller( const EBaseCallback &cb, TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8,TP9 p9 )
{
  Receiver &objReceiver = *(Receiver *)cb._pObjReceiver;
  Member &fnMember = *(Member *)(void *)cb._fnMemberCallback;

   (objReceiver.*fnMember)(p1,p2,p3,p4,p5,p6,p7,p8,p9);
}

#endif // !defined(AFX_ECALLBACK9T_H__B78AA269_D476_11D2_BD55_0040053AD648__INCLUDED_)
