// EHashAssoCleanerT.h: interface for the EHashAssoCleanerT class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EHASHASSOCLEANERT_H__34E84053_E109_11D2_9222_004005446EE6__INCLUDED_)
#define AFX_EHASHASSOCLEANERT_H__34E84053_E109_11D2_9222_004005446EE6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*! \class EHashAssoCleanerT<Key,Item>
 * \include "EHashAssoCleanerT.h"
 * \brief Association cleaner for the EHash template.
 */
template<class Key, class Item>
class EHashAssoCleanerT  
{
public:
  EHashAssoCleanerT() {}
  virtual ~EHashAssoCleanerT() {}

  virtual void freeAsso( Key &key, Item &item ) {}

};


/*! \class EHashAssoCleanerPtrT<Key,Item>
 * \include "EHashAssoCleanerT.h"
 * \brief Association cleaner for the EHash template which item is a pointer.
 */
template<class Key, class Item>
class EHashAssoCleanerPtrT : public EHashAssoCleanerT<Key,Item>
{
public:
  EHashAssoCleanerPtrT() {}
  virtual ~EHashAssoCleanerPtrT() {}

  /*! Deletes the object pointed by the item.
   */
  virtual void freeAsso( Key &key, Item &item );

};

template<class Key, class Item>
void 
EHashAssoCleanerPtrT<Key,Item>::freeAsso( Key &key, Item &item )
{
  if ( item )
    delete item;
}


#endif // !defined(AFX_EHASHASSOCLEANERT_H__34E84053_E109_11D2_9222_004005446EE6__INCLUDED_)
