// EIteratorT.h: interface for the EIteratorT class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EITERATORT_H__042C39A6_DF07_11D2_BD6C_0040053AD648__INCLUDED_)
#define AFX_EITERATORT_H__042C39A6_DF07_11D2_BD6C_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/*! \file EIterator.h
 * \brief This class represents an abstract iterator.
 */
template<class TElm>
class EIteratorT  
{
public:
  EIteratorT() {}
  virtual ~EIteratorT() {}

  /*! Sets the iterator at the beginning of the table.
   */
  virtual void begin() =0;

  /*! Tests if there is still some element to be read.
   * @return \c false if there is no more element to read, otherwise returns \c true.
   */
  virtual bool isEnd() const =0;

  /*! Moves the iterator to the next association.
   */
  virtual void next() =0;

  /*! Gets the item at the current position of the iterator.
   * @return Item at the current position of the iterator.
   */
  virtual TElm& item() =0;

  /*! Gets the item at the current position of the iterator.
   * @return Item at the current position of the iterator.
   */
  virtual const TElm& item() const =0;

  /*! Gets the number of items.
   * @return Number of items.
   */
  virtual SL count() const =0;
};

#endif // !defined(AFX_EITERATORT_H__042C39A6_DF07_11D2_BD6C_0040053AD648__INCLUDED_)
