// EObjectContext.cpp: implementation of the EObjectContext class.
//
//////////////////////////////////////////////////////////////////////

#include "usuel.hpp"
#include "EClassId.h"
#include "EObjectContext.h"
#include "EString.hpp"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

EObjectContext::EObjectContext( const EClassId &clsidObject )
{
  _nVersion = clsidObject.version();
  _pClsidObject = &clsidObject;
}


EDataStream &
operator <<( EDataStream &s,
             const EObjectContext &ctx )
{
  s << ctx.version();
  s.writeCStr( ctx.clsid().className().cstr() );
  return s;
}


EDataStream &
operator >>( EDataStream &s,
             EObjectContext &ctx )
{
  UL nVersion;
  s  >>  nVersion;
  ctx.setVersion( nVersion );
  EString strClassName;
  s.readCStr( strClassName );
  const EClassId *pClsid = EClassId::findClass( strClassName );
  EASSERT( pClsid );

  // should throw an exception if class not found !
  
  ctx.setClass( *pClsid );
  return s;
}
