// EStoreObjectPrp.h: interface for the EStoreObjectPrp class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ESTOREOTPRP_H__EC212971_73FE_11D3_BE94_0040053AD648__INCLUDED_)
#define AFX_ESTOREOTPRP_H__EC212971_73FE_11D3_BE94_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "EStorePrpType.h"

class EStoreOtPrp  
{
public:
  typedef UL PrpValueType;
  
  enum
  {
    pvtpNone =0,
    pvtpString,
    pvtpNumber,
    pvtpBinary,

    // First enum value available for derived classes.
    pvtpFirst,
  };


	EStoreOtPrp( EStorePrpType esptpPrp,
                   const EString &strValue,
                   bool bIsEncoding =true );

	EStoreOtPrp( EStorePrpType esptpPrp,
                   SL nValue );

	EStoreOtPrp( EStorePrpType esptpPrp,
                   UL ulValue );

	EStoreOtPrp( EStorePrpType esptpPrp,
                   double flValue );

	EStoreOtPrp( EStorePrpType esptpPrp = pvtpNone );

	virtual ~EStoreOtPrp();

  virtual bool isValid();
  virtual bool isValidString();
  virtual bool isValidBinary();
  virtual bool isValidNumber();

  virtual SL valLong();
  virtual UL valULong();
  virtual double valDouble();
  virtual void valString( EString &strValue );
  EString valString();
  virtual void valBinary();

  virtual void setValLong( SL nValue );
  virtual void setValULong( UL ulValue );
  virtual void setValDouble( double flValue );
  virtual void setValString( const EString &strValue );
  virtual void setValBinary();

  EStorePrpType prpType() const;
  virtual PrpValueType valueType() const;
  virtual const EString &encodedPrp() const;

protected:
  void setValueType( PrpValueType pvtpValue );
  void setEncodedPrp( const EString &strValEnc );

private:
  /** Type of property value.
   */
  PrpValueType _pvtpValue;

  /** Property name.
   */
  EStorePrpType _esptpPrp;

  /** Encoded property value.
   */
  EString _strValEnc;
};




inline void 
EStoreOtPrp::setValueType( PrpValueType pvtpValue )
{
  _pvtpValue = pvtpValue;
}


inline EStoreOtPrp::PrpValueType 
EStoreOtPrp::valueType() const
{
  return _pvtpValue;
}


inline const EString &
EStoreOtPrp::encodedPrp() const
{
  return _strValEnc;
}


inline void 
EStoreOtPrp::setEncodedPrp( const EString &strValEnc )
{
  _strValEnc = strValEnc;
}


inline EStorePrpType 
EStoreOtPrp::prpType() const
{
  return _esptpPrp;
}


inline EString 
EStoreOtPrp::valString()
{
  EString strValue;
  valString( strValue );
  return strValue;
}


#endif // !defined(AFX_ESTOREOTPRP_H__EC212971_73FE_11D3_BE94_0040053AD648__INCLUDED_)
