// EStringKeyProviderT.h: interface for the EStringKeyProviderT class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ESTRINGKEYPROVIDERT_H__992AFCED_3D03_11D3_BE1D_0040053AD648__INCLUDED_)
#define AFX_ESTRINGKEYPROVIDERT_H__992AFCED_3D03_11D3_BE1D_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/*! \brief Hash key provider for a case sensitive string.
 * @param StringRef Non-const reference on the string class.
 */
template<class StringRef>
class EStringKeyProviderT : public EHashKeyProviderT<StringRef>
{
public:
  EStringKeyProviderT() {}
  virtual ~EStringKeyProviderT() {}

  virtual UL getKey( StringRef strName ) const
  {
    return strName.makeHashKey();
  }

  virtual bool compareKey(  StringRef strKey1,StringRef strKey2 ) const
  {
    return strKey1 == strKey2;
  }
};

/*! \brief Hash key provider for a case insensitive string.
 * @param StringRef Non-const reference on the string class.
 */
template<class StringRef>
class EStringNcsKeyProviderT : public EHashKeyProviderT<StringRef>
{
public:
  EStringNcsKeyProviderT() {}
  virtual ~EStringNcsKeyProviderT() {}

  virtual UL getKey( StringRef strName ) const
  {
    return strName.imakeHashKey();
  }

  virtual bool compareKey( StringRef strKey1, StringRef strKey2 ) const
  {
    return strKey1.icmp( strKey2 ) == 0;
  }
};

#endif // !defined(AFX_ESTRINGKEYPROVIDERT_H__992AFCED_3D03_11D3_BE1D_0040053AD648__INCLUDED_)
