// ###########################################################################
// File: EBINTREE.CPP
// (c)Copyright 03/1998, Lepilleur Baptiste (Aka Elyon from Zuul Design)
// ###########################################################################

#include "usuel.hpp"
#include "ebintree.hpp"

/** Recursing removing all node of a subtree.
  * @param pNode subtree root.
  */
void EBinTreeNode::removeSubtreeRecurse()
{
  if ( leftST() )
    leftST()->removeSubtree();
  if ( rightST() )
    rightST()->removeSubtree();
  delete this;
}

/** Remove all node of a subtree.
 * @param pNode subtree root.
 */
void EBinTreeNode::removeSubtree()
{
  if ( leftST() )
    leftST()->removeSubtreeRecurse();
  if ( rightST() )
    rightST()->removeSubtreeRecurse();

  EBinTreeNode *pParent = parentNode();
  if ( pParent )
  {
    if ( pParent->leftST() == this )
      pParent->setLST( ENIL );
    else
      pParent->setRST( ENIL );
  }
  delete this;
}


// ########################### EOF EBINTREE.CPP ##############################
// ########################### EOF EBINTREE.CPP ##############################
// ########################### EOF EBINTREE.CPP ##############################

