// EDragFileList.h: interface for the CEDragFileList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EDRAGFILELIST_H__4CB59AC1_903E_11D1_91CF_B32000EA6861__INCLUDED_)
#define AFX_EDRAGFILELIST_H__4CB59AC1_903E_11D1_91CF_B32000EA6861__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000



#include <afxcoll.h>

class CWinApp;

/* This class is used to get the list of dropped file. (using Drag'n'Drop).
   Here is a typical used (add a WM_DROPFILES handler to CMainFrame). It opens each dropped files.

  void CMainFrame::OnDropFiles(HDROP hDropInfo) 
  {
    CEDragFileList fileList( hDropInfo );
    fileList.OpenDocuments( &theApp );
  }
*/
class CEDragFileList  
{
public:
  // Default constructor. 
  // You must call BuildList() to do something with that class.
  CEDragFileList();

  // Create the list of dropped files. ( see BuildList() )
  CEDragFileList( HDROP hDrop );

  ~CEDragFileList();

  // Get the list of file from hDrop using ::DropQueryFile.
  // hDrop: file description given by message WM_DROPFILES & method OnDropFiles.
	void BuildList( HDROP hDrop);

  // Run CWinApp::OpenDocumentFile( fileName ) for each file of the list.
	void OpenDocuments(  CWinApp *app ) const;

  // Return the list of dropped files.
  const CStringArray& GetList() const;

private:

  // List of dropped files
  CStringArray m_files;
};

inline const CStringArray& CEDragFileList::GetList() const
{
  return m_files;
}


#endif // !defined(AFX_EDRAGFILELIST_H__4CB59AC1_903E_11D1_91CF_B32000EA6861__INCLUDED_)
