// EwgDlgFindText.cpp : implementation file
//

#include "stdafx.h"
#include "ttr.h"
#include "EwgDlgFindText.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EwgDlgFindText dialog

// Registered message sent when Ok is cliked.
UINT EwgDlgFindText_msgOnFind = 
    ::RegisterWindowMessage( _T( "EwgDlgFindText::OnFind" ) );


EwgDlgFindText::EwgDlgFindText(CWnd* pParent )
	: CDialog(EwgDlgFindText::IDD, pParent)
{
	//{{AFX_DATA_INIT(EwgDlgFindText)
	_strFindText = _T("");
	_bMatchWholeWord = FALSE;
	_bMatchCase = FALSE;
	//}}AFX_DATA_INIT
}


BOOL
EwgDlgFindText::Create()
{
  return CDialog::Create( IDD, _pParentWnd );
}


void 
EwgDlgFindText::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EwgDlgFindText)
	DDX_Control(pDX, IDOK, _btnOk);
	DDX_Control(pDX, IDC_FIND_TEXT, _cbFindText);
	DDX_CBString(pDX, IDC_FIND_TEXT, _strFindText);
	DDX_Check(pDX, IDC_MATCH_CASE, _bMatchCase);
	DDX_Check(pDX, IDC_MATCH_WHOLE_WORD, _bMatchWholeWord);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(EwgDlgFindText, CDialog)
	//{{AFX_MSG_MAP(EwgDlgFindText)
	ON_CBN_EDITCHANGE(IDC_FIND_TEXT, OnEditchangeFindText)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EwgDlgFindText message handlers


void 
EwgDlgFindText::OnOK() 
{
  UpdateData();

  if ( _strFindText.IsEmpty() )
    return;

  if ( _cbFindText.GetCount() > 15 )      // keep only 16 strings in the combo.
  {
    _cbFindText.DeleteString( 15 );
  }

  _cbFindText.InsertString( 0, _strFindText );   // Insert string at the beginning.

  ShowWindow( SW_HIDE );

  EwgFindTextInfo info;
  prepareFindInfo( info, false );

  AfxGetApp()->m_pMainWnd->SendMessage( EwgDlgFindText_msgOnFind,
                                        (WPARAM)&info );
}


void 
EwgDlgFindText::OnCancel() 
{
  ShowWindow( SW_HIDE );
}


BOOL 
EwgDlgFindText::OnInitDialog() 
{
	CDialog::OnInitDialog();
  OnEditchangeFindText();
	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void 
EwgDlgFindText::OnEditchangeFindText() 
{
  UpdateData();

  _btnOk.EnableWindow( !_strFindText.IsEmpty() );
}


bool 
EwgDlgFindText::prepareFindInfo( EwgFindTextInfo &info,
                                 bool bSearchAgain )
{
  if ( GetSafeHwnd() )
  {
    UpdateData();
    
    if ( _strFindText.GetLength() )
    {
      info._strText = _strFindText;
      info._bMatchWholeWord = (_bMatchWholeWord != FALSE);
      info._bMatchCase = (_bMatchCase != FALSE );
      info._bIsSearchAgain = bSearchAgain;
      return true;
    }
  }

  return false;
}


bool
EwgDlgFindText::SearchAgain()
{
  EwgFindTextInfo info;
  if ( !prepareFindInfo( info, true ) )
    return false;

  AfxGetApp()->m_pMainWnd->SendMessage( EwgDlgFindText_msgOnFind,
                                        (WPARAM)&info );
  return true;
}


void 
EwgDlgFindText::SetDefaultFocus()
{
  if ( GetSafeHwnd() )
    if ( _cbFindText.GetSafeHwnd() )
      _cbFindText.SetFocus();
}
