// //////////////////////////////////////////////////////////////////////////
// Implementation file TtrFmtTextComparator.cpp for class TtrFmtTextComparator
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/04/07
// //////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "CppUnit.h"
#include "TtrFmtTextComparator.h"
#include "TtrFmtBlank.h"
#include "TtrFmtPara.h"
#include "TtrFmtText.h"


void 
TtrFmtTextComparator::compare( const TtrFmtText &text, 
                               const TtrFmtText &textComparedTo )
{
  TtrFmtTextComparator comparator( textComparedTo );
  const_cast<TtrFmtText &>(text).visit( comparator );
  GAIACRTN_ASSERT_EQUAL( text.eltCount(), textComparedTo.eltCount() );
}


TtrFmtTextComparator::TtrFmtTextComparator( const TtrFmtText &text ) :
     _text( text ),
     _nIdx( 0 )
{
}

TtrFmtTextComparator::~TtrFmtTextComparator()
{
}


void 
TtrFmtTextComparator::visitBlank( TtrFmtBlank &blank )
{
  checkSize();
  const TtrFmtElt &elt = _text.eltAt( _nIdx++ );
  GAIACRTN_ASSERT_EQUAL( blank.type(), elt.type() );
  const TtrFmtBlank &blank2 = (TtrFmtBlank &)elt;
  GAIACRTN_ASSERT( blank == blank2 );
}


void 
TtrFmtTextComparator::visitPara( TtrFmtPara &para )
{
  checkSize();
  const TtrFmtElt &elt = _text.eltAt( _nIdx++ );
  GAIACRTN_ASSERT_EQUAL( para.type(), elt.type() );
  const TtrFmtPara &para2 = (TtrFmtPara &)elt;
  GAIACRTN_ASSERT( para == para2 );
}


void 
TtrFmtTextComparator::checkSize() 
{
  GAIACRTN_ASSERT( _nIdx < _text.eltCount() );
}
