// //////////////////////////////////////////////////////////////////////////
// Header file TtrFmtTextComparator.h for class TtrFmtTextComparator
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/04/07
// //////////////////////////////////////////////////////////////////////////
#ifndef TTRFMTTEXTCOMPARATOR_H
#define TTRFMTTEXTCOMPARATOR_H

#include "TtrFmtEltVisitor.h"
class TtrFmtText;

/*! \class TtrFmtTextComparator
 * \brief This class compares two formatted text (for unit testing).
 */
class TtrFmtTextComparator : public TtrFmtEltVisitor
{
public:
  static void compare( const TtrFmtText &text, 
                       const TtrFmtText &textComparedTo );

private:
  /*! Constructs a TtrFmtTextComparator object.
   */
  TtrFmtTextComparator( const TtrFmtText &text );

  /*! Destructor.
   */
  virtual ~TtrFmtTextComparator();

  /*! Visits a blank block.
   * @param blank Blank block.
   */
  virtual void visitBlank( TtrFmtBlank &blank );

  /*! Visits a paragraph.
   * @param para Paragraph.
   */
  virtual void visitPara( TtrFmtPara &para );

private:
  void checkSize();

  /*! Prevents the use of the copy constructor.
   */
  TtrFmtTextComparator( const TtrFmtTextComparator &copy );

  /*! Prevents the use of the copy operator.
   */
  TtrFmtTextComparator &operator =( const TtrFmtTextComparator &copy );

private:
  const TtrFmtText &_text;
  SL _nIdx;
};



// Inlines methods for TtrFmtTextComparator:
// -----------------------------------------



#endif  // TTRFMTTEXTCOMPARATOR_H
