// //////////////////////////////////////////////////////////////////////////
// Implementation file TtrFmtTextDumper.cpp for class TtrFmtTextDumper
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/04/07
// //////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "TtrFmtTextDumper.h"
#include "TtrFmtBlank.h"
#include "TtrFmtPara.h"
#include "TtrFmtText.h"


void 
TtrFmtTextDumper::dump( const TtrFmtText &text, 
                        const EString &strTitle )
{
  TtrFmtTextDumper dumper;
  TRACE( "###>>>Dumping TtrFmt: %s\n", strTitle.datas() );
  const_cast<TtrFmtText &>(text).visit( dumper );
  TRACE( "###<<<End Dumping TtrFmt: %s\n", strTitle.datas() );
}


TtrFmtTextDumper::TtrFmtTextDumper() : 
    TtrFmtEltVisitor()
{
}


TtrFmtTextDumper::~TtrFmtTextDumper()
{
}


void 
TtrFmtTextDumper::visitBlank( TtrFmtBlank &blank )
{
  TRACE( "<Blank,linecount=%d>\n",
         blank.lineCount());
}


void 
TtrFmtTextDumper::visitPara( TtrFmtPara &para )
{
  TRACE( "<Para,il=%d,is=%s>={%s}\n", 
         para.indent().indentLevel(),
         para.indent().indentString().cstr(),
         para.content().cstr() );
}
