// TtrSettingManager.h: interface for the TtrSettingManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TTRSETTINGMANAGER_H__4B4B8960_6406_45B9_B308_E21E8EC748F5__INCLUDED_)
#define AFX_TTRSETTINGMANAGER_H__4B4B8960_6406_45B9_B308_E21E8EC748F5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TtrGlobalSetting.h"
#include "TtrAutoDetectCtx.h"
class TtrText;


/*! \class TtrSettingManager
 * \brief This class manages the settings.
 */
class TtrSettingManager  
{
public:
  /*! Constructs a setting manager.
   * @param setting Setting to manage.
   */
	TtrSettingManager( TtrGlobalSetting &setting );

  /*! Destructor.
   */
	virtual ~TtrSettingManager();

  /*! Autodetect format setting using heuristic.
   * @param text Text on which setting autodetection is based.
   */
  void autoDetectFormatSetting( TtrText &text );

  /*! Returns the format setting.
   * @return Reference on the format setting.
   */
  TtrFormatSetting &formatSetting();

private:

private:
  /*! Pointer on the format setting. Not owned by the manager. Can not be \c NULL.
   */
  TtrGlobalSetting *_pSetting;
};


inline TtrFormatSetting &
TtrSettingManager::formatSetting()
{
  return *_pSetting;
}


#endif // !defined(AFX_TTRSETTINGMANAGER_H__4B4B8960_6406_45B9_B308_E21E8EC748F5__INCLUDED_)
