// //////////////////////////////////////////////////////////////////////////
// Header file TtrTagAttList.h for class TtrTagAttList
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2000/09/09
// //////////////////////////////////////////////////////////////////////////
#ifndef TTRTAGATTLIST_H
#define TTRTAGATTLIST_H

#include "TtrTagAtt.h"
class TtrTagAttList;


/*! Type for reference on object of type TtrTagAttList.
 */
typedef ERef<TtrTagAttList> TtrTagAttListRef;



/*! \class TtrTagAttList
 * \brief This class represents a list of tag's attributs
 */
class TtrTagAttList : public ERefObj
{
public:
  /*! Constructs a TtrTagAttList object.
   */
  TtrTagAttList();

  /*! Destructor.
   */
  virtual ~TtrTagAttList();

  /*! Adds a tag to the list.
   * @param refTag Reference on the tag to add.
   */
  void addTag( const TtrTagAttRef &refTag );

private:
  /*! Prevents the use of the copy constructor.
   */
  TtrTagAttList( const TtrTagAttList &copy );

  /*! Prevents the use of the copy operator.
   */
  TtrTagAttList &operator =( const TtrTagAttList &copy );

private:
  typedef EObjDynArrayT<TtrTagAttRef> ArrayTagAtt;
  ArrayTagAtt _aTagAtt;
};



// Inlines methods for TtrTagAttList:
// ----------------------------------



#endif  // TTRTAGATTLIST_H
