// Generated by Together

#ifndef TTRTEXTBLOCK_H
#define TTRTEXTBLOCK_H

#include "TtrTextBlockDef.h"
#include "TtrText.h"


class TtrTextBlock 
{
public:
  TtrTextBlock();
  TtrTextBlock( TtrText &text,
                SL nFirstLine,
                SL nLastLine );
  bool isValid() const;
  
  const TtrTextBlockDef & range() const;

  TtrTextBlockDef & range();

  const TtrText &text() const;

  TtrText &text();

  bool bound();

  /*! Makes the block the whole text if it is empty.
   */
  void setToAllIfEmpty();

private:
  /**Text the block belong to.
   * @shapeType AggregationLink
   * @supplierCardinality 1 
   */
  TtrText *_pText;

  /** Block range.*/
  TtrTextBlockDef _defBlock;
};


// Inlines: TtrTextBlock
// ---------------------

inline
TtrTextBlock::TtrTextBlock( TtrText &text,
                            SL nFirstLine,
                            SL nLastLine ) :
    _pText( &text ),
    _defBlock( nFirstLine, nLastLine )
{
}


inline
TtrTextBlock::TtrTextBlock() :
    _pText( NULL )
{
}


inline const TtrText &
TtrTextBlock::text() const
{
  EASSERT( _pText );
  return *_pText;
}


inline TtrText &
TtrTextBlock::text()
{
  EASSERT( _pText );
  return *_pText;
}


inline TtrTextBlockDef & 
TtrTextBlock::range()
{
  return _defBlock;
}


inline const TtrTextBlockDef & 
TtrTextBlock::range() const 
{
  return _defBlock;
}


inline bool 
TtrTextBlock::bound()
{
  return _pText ? _defBlock.bound( text().nbLine() ) : false;
}


#endif //TTRTEXTBLOCK_H


