// Generated by Together

#ifndef TTRTEXTBLOCKDEF_H
#define TTRTEXTBLOCKDEF_H


class TtrTextBlockDef 
{
public:
  /*! Copy constructor.
   * @param copy Object to copy.
   */
  TtrTextBlockDef( const TtrTextBlockDef &copy );

  /*! Constructs a block definition.
   * @param nStartLine First line included in the block.
   * @param nLastLine Last line included in the block.
   */
  TtrTextBlockDef( SL nStartLine =-1, 
                   SL nLastLine =-1 );

  /*! Destructor.
   */
  ~TtrTextBlockDef() {}

  void setLast( SL nLastLine );

  void setFirst( SL nFirstLine );
  void set( SL nStartLine, 
            SL nLastLine );

  SL firstLine() const;

  SL lastLine() const;

  /*! Returns the number of line in the range.
   * @return Number of line the range ( max(0, lastLine() +1 -firstLine() ) ).
   */
  SL lineCount() const;

  /** Test if the block is valid.
   *
   * @return \c true if there is at least one line slected inside the text.
   */
  bool isValid( SL nNbLine ) const;

  /** Set range in semi-valid bound.
    * The first line is between 0 and nNbLine-1 included.
    * The last line is between the first line-1 and nNbLine-1 included.
    * @return Indicates if the block contains at least 1 line.*/
  bool bound( SL nNbLine );

  /*! Assigment operator.
   * @param copy Object to copy.
   */
  TtrTextBlockDef &operator =( const TtrTextBlockDef &copy );

private:
  /** First line of the block.*/
  SL _nFirstLine;

  /** Last line of the block.*/
  SL _nLastLine;
};




// Inlines: TtrTextBlockDef
// ------------------------

inline 
TtrTextBlockDef::TtrTextBlockDef( const TtrTextBlockDef &copy ) :
    _nFirstLine( copy._nFirstLine ),
    _nLastLine( copy._nLastLine )
{
}


inline 
TtrTextBlockDef::TtrTextBlockDef( SL nStart, SL nLast ) :
    _nFirstLine( nStart ),
    _nLastLine( nLast )
{
}


inline void 
TtrTextBlockDef::set( SL nStart, SL nLast )
{
  _nFirstLine = nStart;
  _nLastLine = nLast;
}

inline bool 
TtrTextBlockDef::isValid( SL nNbLine ) const
{
  return _nFirstLine < nNbLine  &&  
         _nLastLine < nNbLine  && 
         _nLastLine >= _nFirstLine;
}


inline SL 
TtrTextBlockDef::firstLine() const 
{
  return _nFirstLine;
}


inline SL 
TtrTextBlockDef::lastLine() const 
{
  return _nLastLine;
}


inline void 
TtrTextBlockDef::setFirst( SL nFirstLine )
{
  _nFirstLine = nFirstLine;
}


inline void 
TtrTextBlockDef::setLast( SL nLastLine )
{
  _nLastLine = nLastLine;
}


inline TtrTextBlockDef &
TtrTextBlockDef::operator =( const TtrTextBlockDef &copy )
{
  _nFirstLine = copy._nFirstLine;
  _nLastLine = copy._nLastLine;
  return *this;
}


inline SL 
TtrTextBlockDef::lineCount() const
{
  return emax( 0, lastLine() +1 -firstLine() );
}



#endif //TTRTEXTBLOCKDEF_H





