// Generated by Together

#ifndef TTRTEXTFORMATERV0_H
#define TTRTEXTFORMATERV0_H

#include "TtrTextFormater.h"
#include "TtrTextLine.h"
#include "TtrGlobalSetting.h"

class RuleIndentationComposite;
class RuleEnclosedComposite;
class RuleContext;

/** @stereotype Formater*/
class TtrTextFormaterV0 : public TtrTextFormater 
{

protected:
  virtual void doFormatBlock( TtrTextBlock &block,
                              TtrFormatSetting &setting ) ;

  /**@shapeType DependencyLink*/
  /*#  RuleContext lnkUnnamed*/
  /**@shapeType DependencyLink*/
  /*#  RuleIndentationIsEosPrev lnkUnnamed1*/
  /**@shapeType DependencyLink*/
  /*#  RuleIndentationBeginWith lnkUnnamed2*/
  /**@shapeType DependencyLink*/
  /*#  RuleIndentationComposite lnkUnnamed3*/
  /**@shapeType DependencyLink*/
  /*#  RuleIndentationIsBlankPrev lnkUnnamed4*/
  /**@shapeType DependencyLink*/
  /*#  RuleIndentationIsSeparator lnkUnnamed5*/
  /**@shapeType DependencyLink*/
  /*#  RuleIndentationIsIndented lnkUnnamed6*/
  /**@shapeType DependencyLink*/
  /*#  RuleIndentationIsScript lnkUnnamed7*/
  /**@shapeType DependencyLink*/
  /*#  RuleIndentationRightMargin lnkUnnamed8*/
  /**@shapeType DependencyLink*/
  /*#  RuleIndentationIsBlank lnkUnnamed9*/
  /**@shapeType DependencyLink*/
  /*#  RuleEnclosedString lnkUnnamed10*/

private:
  /*! Setup Indentation rules.
   * @param setting [In] Settings.
   * @param ruleIndentation [Out] Indentation rules.
   */
  void setupIndentationRules( TtrFormatSetting &setting, 
                              RuleIndentationComposite &ruleIndentation );

  /*! Setup Enclosed rules.
   * @param setting [In] Settings.
   * @param ruleEnclosed [Out] Enclosed rules.
   */
  void setupEnclosedRules( TtrFormatSetting &setting, 
                           RuleEnclosedComposite &ruleEnclosed );

  /*! Apply the centering rule to the current line.
   * @param setting [In] Settings.
   * @param ctx Rule context.
   */
  void applyCenteringRule( TtrFormatSetting &setting, 
                           RuleContext &ctx );

  /*! Detects the indent string.
   * @param ctx Rule context.
   */
  void detectIndentString( RuleContext &ctx );

  /*! Detects the indent string on the specified line.
   * @param ctx Rule context.
   * @param line Line.
   */
  void detectIndentString( RuleContext &ctx,
                           TtrTextLine &line );

};


// Inlines: TtrTextFormaterV0
// --------------------------

#endif //TTRTEXTFORMATERV0_H
