// Generated by Together

#include "StdAfx.h"
#include "TtrTextReaderTxt.h"
#include "TtrTextRaw.h"
#include "EwgProgressInfo.h"


TtrText * 
TtrTextReaderTxt::readText( EDataStream &sText,
                            EwgProgressInfo &progress ) 
{
  TtrText *pText = new TtrTextRaw;
  TtrText &text = *pText;

  SL nSize = sText.device()->size();
  if ( !nSize )
    ++nSize;

  progress.setProgressRange( 0, nSize );
  progress.startProgress();


  EString strLine;
  ETRY
  {
    bool bOneCharAhead = false;
    char cAhead =0;
    do
    {
      strLine.setNull();

      // read line
      do
      {

        char cChar = bOneCharAhead ? cAhead : 
                                     sText.getByte();
        bOneCharAhead = false;

        // Convert Dos & Mac New Line to Unix '\n'
        // New Line:
        // 13,10 : dos (\r\n)
        // 10 : unix (\n)
        // 13 : mac (\r)
        if ( cChar == '\r' )        // Dos or Mac   : convert new line sequence to 1 \n
        {
          cAhead = sText.getByte();
          if ( cAhead != '\n' )     // Mac
          {
            bOneCharAhead = true;
          }
          cChar = '\n';
        }

        // End of line ?
        if ( cChar == '\n' )   // Unix, Dos, Mac New Line
        {
          break;
        }

        // Append char to line
        strLine += cChar;
      }
      while ( true );

      // Append line to text
      appendLine( strLine, text );

      // Update progress bar
      if ( (text.nbLine() & 63) == 0 )
        progress.setProgressValue( sText.device()->at() );
    }
    while ( true );
  }
  ECATCH( EXCIODevice, exc )
  {
    progress.stopProgress();
    if ( exc.cause() != EXCIODevice::endOfFile )    // propagate the exception.
    {
      ETHROW_AGAIN;
    }
    else      // End of file : append current line
    {
      if ( !strLine.isNull() )
        appendLine( strLine, text );
    }
  }

  return pText;
}
