// //////////////////////////////////////////////////////////////////////////
// Implementation file TtrTextWriterHtml.cpp for class TtrTextWriterHtml
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2000/10/04
// //////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "TtrTextWriterHtml.h"
#include "TtrTextWriterHtml.h"
#include "TtrTextReformatter.h"
#include "TtrFmtText.h"
#include "TtrFmtTextBuilder.h"
#include "TtrWriterHtml.h"

void 
TtrTextWriterHtml::writeText( TtrWriterSetting &setting, 
                              TtrFormatSetting &settingFormat, 
                              TtrText &text,           
                              EIODevice &device,
                              EwgProgressInfo &progress )
{
  // Reformats the text
  EAutoPtrT<TtrFmtText> ptrFmtText( new TtrFmtText() );
  TtrFmtTextBuilder builderFmt( *ptrFmtText, setting );
  TtrTextReformatter reformatter( builderFmt );
  reformatter.reformat( text, progress );
  
  // Writes the text
  ETextStream stext( &device );
  TtrWriterHtml writer( stext, setting );
  writer.start();
  ptrFmtText->visit( writer );
  writer.end();
}
