// //////////////////////////////////////////////////////////////////////////
// Implementation file TtrTextWriterWrappedTxt.cpp for class TtrTextWriterWrappedTxt
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2000/10/04
// //////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "TtrTextWriterWrappedTxt.h"
#include "TtrTextReformatter.h"
#include "TtrFmtText.h"
#include "TtrFmtTextBuilder.h"
#include "TtrWriterWrappedTxt.h"



TtrTextWriterWrappedTxt::TtrTextWriterWrappedTxt() : 
    TtrTextWriter()
{
}


TtrTextWriterWrappedTxt::~TtrTextWriterWrappedTxt()
{
}


void 
TtrTextWriterWrappedTxt::writeText( TtrWriterSetting &setting,
                                    TtrFormatSetting &settingFormat, 
                                    TtrText &text,           
                                    EIODevice &device,
                                    EwgProgressInfo &progress )
{
  // Reformats the text
  EAutoPtrT<TtrFmtText> ptrFmtText( new TtrFmtText() );
  TtrFmtTextBuilder builderFmt( *ptrFmtText, setting );
  TtrTextReformatter reformatter( builderFmt );
  reformatter.reformat( text, progress );
  
  // Writes the text
  ETextStream stext( &device );
  TtrWriterWrappedTxt writer( stext, setting );
  writer.start();
  ptrFmtText->visit( writer );
  writer.end();
}

