// //////////////////////////////////////////////////////////////////////////
// Header file TtrUtSymbol.h for class TtrUtSymbol
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2000/09/14
// //////////////////////////////////////////////////////////////////////////
#ifndef TTRUTSYMBOL_H
#define TTRUTSYMBOL_H

#include "CppUnit.h"


/*! \class TtrUtSymbol
 * \brief This class represents a unit test to test ESymbolIdHolder
 */
class TtrUtSymbol : public CppUnit::TestCase
{
  CPPUNIT_TEST_SUITE( TtrUtSymbol );
  CPPUNIT_TEST( getSymbol );
  CPPUNIT_TEST_SUITE_END();

public:
  /*! Constructs a TtrUtSymbol object.
   */
  TtrUtSymbol();

  /*! Destructor.
   */
  virtual ~TtrUtSymbol();

  void getSymbol();

private:
  /*! Prevents the use of the copy constructor.
   */
  TtrUtSymbol( const TtrUtSymbol &copy );

  /*! Prevents the use of the copy operator.
   */
  TtrUtSymbol &operator =( const TtrUtSymbol &copy );

private:
  ESymbolNcsIdHolder _symbolIdHolder;
};



// Inlines methods for TtrUtSymbol:
// --------------------------------



#endif  // TTRUTSYMBOL_H
