// TtrUtWriter.h: interface for the TtrUtWriter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TTRUTWRITTER_H__1470F83B_DBE8_409A_93D7_DA4A0D0276A0__INCLUDED_)
#define AFX_TTRUTWRITTER_H__1470F83B_DBE8_409A_93D7_DA4A0D0276A0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "CppUnit.h"
#include "TtrGlobalSetting.h"
class TtrText;
class EwgProgressInfo;

class TtrUtWriter : public CppUnit::TestCase
{
  CPPUNIT_TEST_SUITE( TtrUtWriter );
  CPPUNIT_TEST( writerTxtOriginal );
  CPPUNIT_TEST( writerTxtIndentTab );
  CPPUNIT_TEST( writerTxtIndent3Tab );
  CPPUNIT_TEST( writerTxtIndentSpace );
  CPPUNIT_TEST( writerTxtIndent3Space );
  CPPUNIT_TEST( writerTxtIndentTabJumpOneLine );
  CPPUNIT_TEST_SUITE_END();
public:

  TtrUtWriter();
	virtual ~TtrUtWriter();

  void writerTxtOriginal();
  void writerTxtIndentTab();
  void writerTxtIndent3Tab();
  void writerTxtIndentSpace();
  void writerTxtIndent3Space();
  void writerTxtIndentTabJumpOneLine();

private:
  void makePara( int nStartLine, int nCount );
  void makeOriginal( int nStartLine, int nCount );
  void setText( const EString &strText );
  void saveAndCheckTxt( const EString &strTestText );
  void reformattedText();
  void originalText();
private:
  TtrGlobalSetting _mode;
  TtrText *_pText;
  EwgProgressInfo *_pProgressInfo;
};

#endif // !defined(AFX_TTRUTWRITTER_H__1470F83B_DBE8_409A_93D7_DA4A0D0276A0__INCLUDED_)
